//+------------------------------------------------------------------+
//|                                               i-Equity_GM_v4.mq4 |
//|                                                        GrayMan77 |
//|                                                                  |
//|  v2 -                                      |
//|                                                                  |
//|  v3 -                              |
//|                                                                  |
//|  v4 -   ;                              |
//|     -     .                         |
//|     (    LendhtChannelBars+StartShift |
//|                                                     StartShift)|
//|  |
//+------------------------------------------------------------------+
#property copyright "GrayMan77"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Goldenrod

//----  

extern int  LendhtChannelBars=500;          // ,     
extern int StartShift=28;
extern double Deposit     = 0;                //  
extern string Type        = "buy;buy;sell";           //   (buy;sell;)
extern string Lots        = "0.1;0.1;0.1";           //  
extern string Symb        = "EURUSD;GBPUSD;USDCHF";     //  
extern bool   ShowComment = True;                //  
extern bool   AccountSwap = True;                //  

//----  
double Equity[];

//-------    -------------------------------------

int    Types[];         // 
double Lots_[];         // 
string Symbols[];      // 

int PozTotal,PozTotal_t,PozTotal_s,PozTotal_l;  //  
bool Error;
datetime StartTime; //    LendhtChannelBars+StartShift
double a,b,bh,bl;
bool NotCalculate;
int NumberWindow;  //   
int StartBar;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Equity);

   //    
   ReadTypes();
   ReadLots();
   ReadSymbol();
   //  
   Error=false;
   if(PozTotal_t!=PozTotal_s || PozTotal_t!=PozTotal_l || PozTotal_s!=PozTotal_l) Error=true;
   PozTotal=PozTotal_t;
   
   //   ,    
   StartTime=Time[LendhtChannelBars+StartShift];
   
   NotCalculate=true;

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  if(ShowComment) Comment("");
  DelObj();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit,i;
   int    counted_bars=IndicatorCounted();
   double T1,T2,Price1,Price2,Delta;
   int AB;

//----
   if(counted_bars<0) return(-1);
   if(Error)
     {
     Print("   !");
     Alert("   !");
     return(-1);
     }
   
   //   1 
  if(NotCalculate)
  {
   
   //   
   StartBar=iBarShift(Symbol(),Period(),StartTime,false);
   
   //---- 
   //for(i=limit;i>=0;i--)
   for(i=StartBar;i>=0;i--)
     {
     //  
     Equity[i]=CalcEquity(i,StartBar);
     }
   
   //   
   RGRCalculate();
   Delta=bh-bl;
   Print("a=",a,"    b=",b,"   bh=",bh,"    bl=",bl,"    Channel=",Delta);
   
   //  
   NumberWindow=WindowFind(WindowExpertName());
    //   
     AB=LendhtChannelBars+StartShift;
     T1=Time[AB];
     T2=Time[StartShift+1];
     Price1=a*AB+b;
     Price2=a*(StartShift+1)+b;
     ObjectCreate("MIDL2",OBJ_TREND,NumberWindow,T1,Price1,T2,Price2);
		   ObjectSet("MIDL2",OBJPROP_COLOR,Lime); 
	   	ObjectSet("MIDL2",OBJPROP_WIDTH,1); 
	   	ObjectSet("MIDL2",OBJPROP_STYLE,STYLE_DOT);
	

     //    
     Price1=a*AB+bh;
     Price2=a*(StartShift+1)+bh;
     ObjectCreate("TL21",OBJ_TREND,NumberWindow,T1,Price1,T2,Price2); 
	   	ObjectSet("TL21",OBJPROP_COLOR,Lime); 
	   	ObjectSet("TL21",OBJPROP_WIDTH,2); 
   		ObjectSet("TL21",OBJPROP_STYLE,STYLE_SOLID); 

     //    
     Price1=a*AB+bl;
     Price2=a*(StartShift+1)+bl;
	  ObjectCreate("TL22",OBJ_TREND,NumberWindow,T1,Price1,T2,Price2); 
		   ObjectSet("TL22",OBJPROP_COLOR,Lime); 
	   	ObjectSet("TL22",OBJPROP_WIDTH,2); 
   		ObjectSet("TL22",OBJPROP_STYLE,STYLE_SOLID);
     
     //    (  StartShift)
     T1=Time[StartShift+1];
     ObjectCreate("VL21",OBJ_VLINE,NumberWindow,T1,0);
         ObjectSet("VL21",OBJPROP_COLOR,Red); 
	   	ObjectSet("VL21",OBJPROP_WIDTH,1); 
   		ObjectSet("VL21",OBJPROP_STYLE,STYLE_SOLID);
   
   NotCalculate=false;
   return(0);
   }
   
   //----    
   
   //----     
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   //----  
   //   
   StartBar=iBarShift(Symbol(),Period(),StartTime,false);
   for(i=limit;i>=0;i--)
     {
     //  
     Equity[i]=CalcEquity(i,StartBar);
     }



//----
   return(0);
  }
//+------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|                                                          |
//+----------------------------------------------------------------------------+
void ReadTypes() {
  int    i=0, np;
  string st, tmp=Type;
  ArrayResize(Types, 0);

  while (StringLen(tmp)>0) {
    np=StringFind(tmp, ";");
    if (np<0) {
      st=tmp;
      tmp="";
    } else {
      st=StringSubstr(tmp, 0, np);
      tmp=StringSubstr(tmp, np+1);
    }
    i++;
    ArrayResize(Types, i);
    PozTotal_t=i-1;
    if (st=="buy") Types[i-1]=0; else Types[i-1]=1;
  }
}

//+----------------------------------------------------------------------------+
//|                                                                 |
//+----------------------------------------------------------------------------+
void ReadLots() {
  int    i=0, np;
  string st, tmp=Lots;
  ArrayResize(Lots_, 0);

  while (StringLen(tmp)>0) {
    np=StringFind(tmp, ";");
    if (np<0) {
      st=tmp;
      tmp="";
    } else {
      st=StringSubstr(tmp, 0, np);
      tmp=StringSubstr(tmp, np+1);
    }
    i++;
    ArrayResize(Lots_, i);
    PozTotal_l=i-1;
    Lots_[i-1]=StrToDouble(st);
  }
}

//+----------------------------------------------------------------------------+
//|                                                              |
//+----------------------------------------------------------------------------+
void ReadSymbol() {
  int    i=0, np;
  string st, tmp=Symb;
  ArrayResize(Symbols, 0);

  while (StringLen(tmp)>0) {
    np=StringFind(tmp, ";");
    if (np<0) {
      st=tmp;
      tmp="";
    } else {
      st=StringSubstr(tmp, 0, np);
      tmp=StringSubstr(tmp, np+1);
    }
    i++;
    ArrayResize(Symbols, i);
    PozTotal_s=i-1;
    Symbols[i-1]=st;
  }
}
//+----------------------------------------------------------------------------+

//+----------------------------------------------------------------------------+
//|   (j - )                                               |
//+----------------------------------------------------------------------------+
double CalcEquity(int j, int StartShift)
  {
  double res, sum, k2, l_bl;
  double ProfitBaseVal; //    
  double ProfitUSD;
  int i;
  string BaseVal;
  
  //   
  sum=0.;
  for(i=0; i<=PozTotal; i++)
    {
    if(Types[i]==0)  // buy
      {
      k2=iClose(Symbols[i],Period(),j);
      ProfitBaseVal=Lots_[i]*MarketInfo(Symbols[i],MODE_LOTSIZE)*(k2-iOpen(Symbols[i],Period(),StartShift))/k2;
      }
    else
      {
      l_bl=Lots_[i]*MarketInfo(Symbols[i],MODE_LOTSIZE);
      ProfitBaseVal=l_bl*iOpen(Symbols[i],Period(),StartShift)/iClose(Symbols[i],Period(),j)-l_bl;
      }
    //    USD
    BaseVal=StringSubstr(Symbols[i],0,3);
    if(BaseVal=="USD") ProfitUSD=ProfitBaseVal;
    if(BaseVal=="EUR") ProfitUSD=ProfitBaseVal*iClose("EURUSD",Period(),j);
    if(BaseVal=="GBP") ProfitUSD=ProfitBaseVal*iClose("GBPUSD",Period(),j);
    if(BaseVal=="AUD") ProfitUSD=ProfitBaseVal*iClose("AUDUSD",Period(),j);
    if(BaseVal=="NZD") ProfitUSD=ProfitBaseVal*iClose("NZDUSD",Period(),j);
    if(BaseVal=="CHF") ProfitUSD=ProfitBaseVal/iClose("USDCHF",Period(),j);
    if(BaseVal=="CAD") ProfitUSD=ProfitBaseVal/iClose("USDCAD",Period(),j);
    
    //  
    sum=sum+ProfitUSD;
    }
  
  //    
  res=sum+Deposit;
  
  return(res);
  }

//+----------------------------------------------------------------------------+
//|                                             |
//|       Equity[]                     |
//|   LendhtChannelBars+StartShift   StartShift                      |
//|      a,b,bh,bl.                             |
//+----------------------------------------------------------------------------+
void RGRCalculate()
  {
  int i;
  double sumX,sumY,sumXY,sumX2,DeltaMax,Delta,RGR;
  
  //     . 
  sumX=0; sumY=0; sumXY=0; sumX2=0;
  for(i=StartShift;i<LendhtChannelBars+StartShift;i++)
    {
    sumX+=i;
    sumY+=Equity[i];
    sumXY+=i*Equity[i];
    sumX2+=i*i;
    }	
  a=(LendhtChannelBars*sumXY-sumX*sumY)/(LendhtChannelBars*sumX2-sumX*sumX);
  b=(sumY-a*sumX)/LendhtChannelBars;
  
  //      
  DeltaMax=0.;
  for(i=StartShift+1; i<LendhtChannelBars+StartShift; i++)
    {
    RGR=a*i+b;
    Delta=MathMax((Equity[i]-RGR),(RGR-Equity[i]));
    if(Delta>DeltaMax) DeltaMax=Delta;
    }
  bh=b+DeltaMax;
  bl=b-DeltaMax;
  
  return;
  }

//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
void DelObj()
  {
  ObjectDelete("TL21");
  ObjectDelete("TL22");
  ObjectDelete("MIDL2");
  ObjectDelete("VL21");
  }